searchData={"content_type":"text/markdown","items":[{"doc":"A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation.\n","ref":"dsl-asharchival-resource.html#archive-archive_related","title":"AshArchival.Resource.archive.archive_related","type":"DSL"},{"doc":"A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern.\n","ref":"dsl-asharchival-resource.html#archive-exclude_destroy_actions","title":"AshArchival.Resource.archive.exclude_destroy_actions","type":"DSL"},{"doc":"A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter.\n","ref":"dsl-asharchival-resource.html#archive-exclude_read_actions","title":"AshArchival.Resource.archive.exclude_read_actions","type":"DSL"},{"doc":"The attribute in which to store the archival flag (the current datetime).","ref":"dsl-asharchival-resource.html#archive-attribute","title":"AshArchival.Resource.archive.attribute","type":"DSL"},{"doc":"A section for configuring how archival is configured for a resource.","ref":"dsl-asharchival-resource.html#archive","title":"AshArchival.Resource.archive","type":"DSL"},{"doc":"An Archival extension for `Ash.Resource`","ref":"AshArchival.html","title":"AshArchival","type":"module"},{"doc":"Configures a resource to be archived instead of destroyed for all destroy actions.\n\nFor more information, see [Archival](/documentation/topics/archival.md)","ref":"AshArchival.Resource.html","title":"AshArchival.Resource","type":"module"},{"doc":"Introspection helpers for `AshArchival.Resource`","ref":"AshArchival.Resource.Info.html","title":"AshArchival.Resource.Info","type":"module"},{"doc":"A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation.","ref":"AshArchival.Resource.Info.html#archive_archive_related/1","title":"AshArchival.Resource.Info.archive_archive_related/1","type":"function"},{"doc":"A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation.","ref":"AshArchival.Resource.Info.html#archive_archive_related!/1","title":"AshArchival.Resource.Info.archive_archive_related!/1","type":"function"},{"doc":"The attribute in which to store the archival flag (the current datetime).","ref":"AshArchival.Resource.Info.html#archive_attribute/1","title":"AshArchival.Resource.Info.archive_attribute/1","type":"function"},{"doc":"The attribute in which to store the archival flag (the current datetime).","ref":"AshArchival.Resource.Info.html#archive_attribute!/1","title":"AshArchival.Resource.Info.archive_attribute!/1","type":"function"},{"doc":"A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern.","ref":"AshArchival.Resource.Info.html#archive_exclude_destroy_actions/1","title":"AshArchival.Resource.Info.archive_exclude_destroy_actions/1","type":"function"},{"doc":"A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern.","ref":"AshArchival.Resource.Info.html#archive_exclude_destroy_actions!/1","title":"AshArchival.Resource.Info.archive_exclude_destroy_actions!/1","type":"function"},{"doc":"A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter.","ref":"AshArchival.Resource.Info.html#archive_exclude_read_actions/1","title":"AshArchival.Resource.Info.archive_exclude_read_actions/1","type":"function"},{"doc":"A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter.","ref":"AshArchival.Resource.Info.html#archive_exclude_read_actions!/1","title":"AshArchival.Resource.Info.archive_exclude_read_actions!/1","type":"function"},{"doc":"archive DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshArchival.Resource.Info.html#archive_options/1","title":"AshArchival.Resource.Info.archive_options/1","type":"function"},{"doc":"# Archival","ref":"archival.html","title":"Archival","type":"extras"},{"doc":"This extension modifies a resource in the following ways.\n\n1. Adds a private `archived_at` `utc_datetime_usec` attribute.\n2. Adds a preparation that filters each action for `is_nil(archived_at)` (except for excluded actions)\n3. Marks all destroy actions as `soft?`, turning them into updates (except for excluded actions)\n4. Adds a change to all destroy actions that sets `archived_at` to the current timestamp\n5. Adds a change that will iteratively load and destroy anything configured in `d:AshArchival.Resource.archive|archive_related`","ref":"archival.html#extension","title":"Extension - Archival","type":"extras"},{"doc":"#","ref":"archival.html#considerations","title":"Considerations - Archival","type":"extras"},{"doc":"`d:AshArchival.Resource.archive|archive_related` is a simple iterative process. It is performed synchronously, and therefore is not suited for large cardinality relationships. Eventually, when bulk actions are supported, this can be migrated to use that. If you need to archive a very large amount of related things, you will need to write a custom change to handle this.","ref":"archival.html#performance-of-archive-related","title":"Performance of Archive Related - Archival","type":"extras"},{"doc":"See the [Unarchiving guide](/documentation/topics/unarchiving.md) For more.","ref":"archival.html#more","title":"More - Archival","type":"extras"},{"doc":"# Un-archiving\n\nAt the moment, there is no way to unarchive an entry with a simple action on that resource. However, if you define a simple resource that uses the same storage under the hood (e.g same database table), but does _not_ use the archival extension. You could then fabricate unarchival with something like this (this is not vetted, it is a pseudo-code example):\n\n```elixir\n# on the archived resource\n# we model it as a create because there is no input record\ncreate :unarchive do\n  manual? true\n  argument :id, :uuid do\n    allow_nil? false\n  end\n\n  change Unarchive\nend\n```\n\nwith an `Unarchive` change like this\n\n```elixir\ndef change(changeset, _, _) do\n  # no data yet, so match on result being `nil`\n  Ash.Changeset.after_action(changeset, fn changeset, nil ->\n    id = Ash.Changeset.get_argument(changeset, :id)\n\n    ResourceWithoutArchival\n    |> Ash.Query.filter(id == ^id)\n    |> Ash.read_one()\n    |> case do\n      {:ok, nil} ->\n        # not found error\n      {:ok, found} ->\n        # unarchive\n        found\n        |> Ash.Changeset.for_update(:update, %{archived_at: nil})\n        |> Ash.update!()\n\n      {:ok, Ash.get!(changeset.resource, id)}\n    end\n  end)\nend\n```","ref":"unarchiving.html","title":"Un-archiving","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshArchival.Resource\n\nConfigures a resource to be archived instead of destroyed for all destroy actions.\n\nFor more information, see [Archival](/documentation/topics/archival.md)","ref":"dsl-asharchival-resource.html","title":"DSL: AshArchival.Resource","type":"extras"},{"doc":"A section for configuring how archival is configured for a resource.\n\n\n\n\n\n\n#","ref":"dsl-asharchival-resource.html#archive","title":"archive - DSL: AshArchival.Resource","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`attribute`](#archive-attribute){: #archive-attribute } | `atom` | `:archived_at` | The attribute in which to store the archival flag (the current datetime). |\n| [`exclude_read_actions`](#archive-exclude_read_actions){: #archive-exclude_read_actions } | `atom \\| list(atom)` | `[]` | A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter. |\n| [`exclude_destroy_actions`](#archive-exclude_destroy_actions){: #archive-exclude_destroy_actions } | `atom \\| list(atom)` | `[]` | A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern. |\n| [`archive_related`](#archive-archive_related){: #archive-archive_related } | `list(atom)` | `[]` | A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation. |\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-asharchival-resource.html#options","title":"Options - DSL: AshArchival.Resource","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,49]}}